--- title: "Express Tutorial: The Local Library website" slug: Learn/Server-side/Express\_Nodejs/Tutorial\_local\_library\_website tags: - Beginner - CodingScripting - Express - Intro - Learn - Node - Tutorial - nodejs - server-side ---

{{LearnSidebar}}

{{PreviousMenuNext("Learn/Server-side/Express\_Nodejs/development\_environment", "Learn/Server-side/Express\_Nodejs/skeleton\_website", "Learn/Server-side/Express\_Nodejs")}}

The first article in our practical tutorial series explains what you'll learn, and provides an overview of the "local library" example website we'll be working through and evolving in subsequent articles.

<table><tbody><tr class="odd"><td>Prerequisites:</td><td>Read the <a href="/en-US/docs/Learn/Server-side/Express_Nodejs/Introduction">Express Introduction</a>. For the following articles you'll also need to have <a href="/en-US/docs/Learn/Server-side/Express_Nodejs/development_environment">set up a Node development environment</a>. </td></tr><tr class="even"><td>Objective:</td><td>To introduce the example application used in this tutorial, and allow readers to understand what topics will be covered. </td></tr></tbody></table>

Overview
--------

Welcome to the MDN "Local Library" Express (Node) tutorial, in which we develop a website that might be used to manage the catalog for a local library. 

In this series of tutorial articles you will:

-   Use the *Express Application Generator* tool to create a skeleton website and application.
-   Start and stop the Node web server.
-   Use a database to store your application's data.
-   Create routes for requesting different information, and templates ("views") to render the data as HTML to be displayed in the browser.
-   Work with forms.
-   Deploy your application to production.

You have learnt about some of these topics already, and touched briefly on others. By the end of the tutorial series you should know enough to develop simple Express apps by yourself.

The LocalLibrary website
------------------------

*LocalLibrary* is the name of the website that we'll create and evolve over the course of this series of tutorials. As you'd expect, the purpose of the website is to provide an online catalog for a small local library, where users can browse available books and manage their accounts.

This example has been carefully chosen because it can scale to show as much or little detail as we need, and can be used to show off almost any Express feature. More importantly, it allows us to provide a *guided* path through the functionality you'll need in any website:

-   In the first few tutorial articles we will define a simple *browse-only* library that library members can use to find out what books are available. This allows us to explore the operations that are common to almost every website: reading and displaying content from a database.
-   As we progress, the library example naturally extends to demonstrate more advanced website features. For example we can extend the library to allow new books to be created, and use this to demonstrate how to use forms and support user authentication.

Even though this is a very extensible example, it's called ***Local**Library* for a reason — we're hoping to show the minimum information that will help you get up and running with Express quickly. As a result we'll store information about books, copies of books, authors and other key information. We won't however be storing information about other items a library might lend, or provide the infrastructure needed to support multiple library sites or other "big library" features. 

I'm stuck, where can I get the source?
--------------------------------------

As you work through the tutorial we'll provide the appropriate code snippets for you to copy and paste at each point, and there will be other code that we hope you'll extend yourself (with some guidance).

Instead of copying and pasting all the code snippets, try typing them out, It'll benefit you in the long run as you'll be more familiar with the code next time you come to write something similar. 

If you get stuck, you can find the fully developed version of the website [on Github here](https://github.com/mdn/express-locallibrary-tutorial).

**Note:** The specific versions of node, Express, and the other modules that this documentation was tested against are listed in the project [package.json](https://github.com/mdn/express-locallibrary-tutorial/blob/master/package.json).

Summary
-------

Now that you know a bit more about the *LocalLibrary* website and what you're going to learn, it's time to start creating a [skeleton project](/en-US/docs/Learn/Server-side/Express_Nodejs/skeleton_website) to contain our example.

{{PreviousMenuNext("Learn/Server-side/Express\_Nodejs/development\_environment", "Learn/Server-side/Express\_Nodejs/skeleton\_website", "Learn/Server-side/Express\_Nodejs")}}

In this module
--------------

-   [Express/Node introduction](/en-US/docs/Learn/Server-side/Express_Nodejs/Introduction)
-   [Setting up a Node (Express) development environment](/en-US/docs/Learn/Server-side/Express_Nodejs/development_environment)
-   [Express Tutorial: The Local Library website](/en-US/docs/Learn/Server-side/Express_Nodejs/Tutorial_local_library_website)
-   [Express Tutorial Part 2: Creating a skeleton website](/en-US/docs/Learn/Server-side/Express_Nodejs/skeleton_website)
-   [Express Tutorial Part 3: Using a Database (with Mongoose)](/en-US/docs/Learn/Server-side/Express_Nodejs/mongoose)
-   [Express Tutorial Part 4: Routes and controllers](/en-US/docs/Learn/Server-side/Express_Nodejs/routes)
-   [Express Tutorial Part 5: Displaying library data](/en-US/docs/Learn/Server-side/Express_Nodejs/Displaying_data)
-   [Express Tutorial Part 6: Working with forms](/en-US/docs/Learn/Server-side/Express_Nodejs/forms)
-   [Express Tutorial Part 7: Deploying to production](/en-US/docs/Learn/Server-side/Express_Nodejs/deployment)
